/*

   XPR door
   ========

   This door provides access to the XPR Libraries for HBBS so that you can up
   and download files.

   the TRANSFER door will call this most of the time.  It takes the following options

   N_ND->ActiveDoor->SystemOptions
   ===============================

   None.

   dooroptions
   ===========

   <xpr<lib>.library>

   TAGS [NOWAREZ] [NOSYSTEM]

   W=<upload path>         filenames are added to this if open() fails..
                           note: *** MUST *** be specified BEFORE any U=<file> parameter!

   D=<download path>       you should normally only specify one place and that should
                             be HBBS:Nodes/NodeX/Playpen/ (or wherever the node's playpen is..)

                            IMPORTANT:  must have trailing / or :
                            --> not any more! 9/jul/1996

   U=<file to upload>      you can specify more than one of these only if the protocol
                             is a batch upload protocol
                             e.g.
                             U=dh2:warez/miggy/hotsoft.lha
                             U=dh2:warez/miggy/newsoft.lha
                             ....

   S                       tells xpr to skip files that are present in the current
                           conference's download directories.

   C                       tells xpr to remove users credits for transferred files

   O=<xprlibrary options>  some options for the xpr library..

   E.G.  (examples are for node 3)

     to download users tagged files and remove creds

       XPR 3 xprzmodem.library TAGS C

     get some files into the node's playpen.

       XPR 3 xprzmodem.library S D=HBBS:Nodes/Node3/PlayPen/


   todo
   ====

   move files if they are fucked as soon as they are fclose'd
   also need to call background filechecker here too..

   implement L=<text file with list of files to upload>


   notes
   =====

   You've no idea how much hassle this door was to write..! :-)


*/

#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>

#include <devices/serial.h>
#include <devices/timer.h>

#include <dos/dosextens.h>
#include <intuition/screens.h>
#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>
#include <diskfont/diskfont.h>
#include <utility/utility.h>
#include <graphics/gfxbase.h>
#include <workbench/workbench.h>
#include <graphics/scale.h>
#include <clib/wb_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/graphics_protos.h>
#include <clib/utility_protos.h>
#include <clib/diskfont_protos.h>

#include "xpr_gui.h"

#ifdef __SASC
int CXBRK(void) { return(0); }
int _CXBRK(void) { return(0); }
void chkabort(void) {}
#endif

#include <HBBS/ANSI_Codes.h>
#include <HBBS/Defines.h>
#include <HBBS/types.h>
#include <HBBS/structures.h>
#include <HBBS/hbbscommon_protos.h>
#include <HBBS/hbbscommon_pragmas.h>
#include <HBBS/Hbbsnode_protos.h>
#include <HBBS/Hbbsnode_pragmas.h>
#include <HBBS/release.h>
char *versionstr="$VER: XPR "RELEASE_STR;

struct Library *HBBSCommonBase=NULL;
struct Library *HBBSNodeBase=NULL;
struct TextFont *HBBSFont=NULL;
struct BBSGlobalData *BBSGlobal=NULL;
struct NodeData *N_ND=NULL;
int N_NodeNum=-1;
char outstr[1024];
long __near __stack=16384;

struct FileBuffer
{
  struct Node node; // filename in ln_Name
  BPTR FH;
  ULONG BytesTransferred;
  ULONG BlocksTransferred;
  ULONG ActualSize;
  BOOL Testing;
  BOOL ReadFile;

};

#include "xproto.h"  // XPR protocol stuff...


UBYTE ZModemCancel[] =
{
  24,24,24,24,24,24,24,24,24,24,
   8, 8, 8, 8, 8, 8, 8, 8, 8, 8
};

// *** Flags

BOOL TWindowOpen=FALSE;
BOOL CheckConfPaths=FALSE;
  // if set then xpr_fopen() has to check all the Conf->Download paths for an existing file
  // and skip it if the file already exists.
BOOL TakeCreds=FALSE;
BOOL xprseropen;
// *** File Info

struct List *UL_FileList=NULL; // a list of FileBuffer nodes..
LONG UL_Files=0;

struct List *DL_FileList=NULL; // a list of FileBuffer nodes..
LONG DL_Files=0;

UBYTE *DL_Path=NULL;
BOOL DL_PathOK=FALSE;

UBYTE *UL_Path=NULL;
BOOL UL_PathOK=FALSE;

struct FileBuffer *CurrentFile=NULL;
LONG CurrentFileNum=1;

#define T_SEND 1
#define T_RECEIVE 2

ULONG TransferType=0;

// ** Stuff for the XPR bit..

UBYTE *xprlibname=NULL;
UBYTE *xprlibopts=NULL;

struct Library *XProtocolBase;
struct XPR_IO *xio;

struct timerequest *treq;
struct MsgPort *tport;
char timeropen;

struct IOExtSer theserio;

struct IOExtSer *xpr_serio;
struct MsgPort *NewPort,*OldPort;

// ************* Misc Functions ***************

VOID cleanup(ULONG num)
{
  if (HBBSNodeBase)
  {
    HBBS_CleanUpDoor();
    CloseLibrary (HBBSNodeBase);
  }

  if (HBBSCommonBase)
  {
    HBBS_CleanUpCommon();
    CloseLibrary (HBBSCommonBase);
  }

  if (num) printf("Door Error = %d\n",num);

  exit(0);
}

static VOID init(char *name)
{
  if(!(HBBSCommonBase = OpenLibrary("HBBSCommon.library",0)))
  {
    cleanup(1);
  }

  if (!(HBBS_InitCommon()))
  {
    cleanup(2);
  }

  if(!(HBBSNodeBase = OpenLibrary("HBBSNode.library",0)))
  {
    cleanup(3);
  }

  if (!(HBBS_InitDoor(N_NodeNum,name)))
  {
    cleanup(4);
  }
  SetProgramName(name);
}


// ************* Main Door Functions ***************

// Timer Routines..

long opentimer(void)
{
  if (!(treq=AllocVec(sizeof(struct timerequest),MEMF_CLEAR|MEMF_PUBLIC)))
  {
    return(-1);
  }
  if(!(tport=CreateMsgPort()))
  {
    FreeVec(treq);
    return(-1);
  }
  treq->tr_node.io_Message.mn_ReplyPort=tport;
  if (OpenDevice("timer.device",UNIT_VBLANK,(struct IORequest*)treq,0))
  {
    DeleteMsgPort(tport);
    FreeVec(treq);
    return(-1);
  }
  timeropen=1;
  return(0);
}

static void closetimer(void)
{
  if(treq)
  {
    if(timeropen) CloseDevice((struct IORequest*)treq);
    if(tport) DeleteMsgPort(tport);
    FreeVec(treq);
  }
}

void qtimer(ULONG micros)
{
/*
  long secs=0;
  if (micros > 1000000)
  {
    secs = micros / 1000000;
    micros = micros % 1000000;
  }
  treq->tr_time.tv_micro=micros;
  treq->tr_time.tv_secs=secs;
*/

  treq->tr_time.tv_micro=micros % 1000000;
  treq->tr_time.tv_secs=micros / 1000000;

  treq->tr_node.io_Command=TR_ADDREQUEST;
  SetSignal(0,1L<<tport->mp_SigBit);
  SendIO((struct IORequest*)treq);
}

BOOL GrabSerial( void )
{
  AbortSerRead(); // just in case there are any pending serial requests..
  xprseropen=FALSE;
  xpr_serio=NULL;
  if(!(NewPort=CreatePort(0,0)))
    return(FALSE);

  if (xpr_serio=(struct IOExtSer *) CreateExtIO(NewPort,(ULONG)sizeof(struct IOExtSer)))
  {
    if (N_ND->NodeDevice.NullModemCable)
    {
      xpr_serio->io_SerFlags       = SERF_SHARED;
    }
    else
    {
      xpr_serio->io_SerFlags       = SERF_SHARED|SERF_7WIRE|SERF_XDISABLED|SERF_RAD_BOOGIE;
    }
    if (!(OpenDevice((STRPTR)N_ND->NodeDevice.SerialDevice,(ULONG)N_ND->NodeDevice.SerialUnit,(struct IORequest *)xpr_serio,0L) ))
    {
      xprseropen=TRUE;
      xpr_serio->IOSer.io_Command  = CMD_RESET;
      DoIO((struct IORequest *)xpr_serio);


      // setup port with correct baud rate etc..
      xpr_serio->IOSer.io_Command  = SDCMD_SETPARAMS;
      xpr_serio->io_SerFlags       |= SERF_XDISABLED;
      xpr_serio->io_Baud           = N_ND->NodeDevice.SerialBaud;
      DoIO((struct IORequest *)xpr_serio);

      SetSignal(0,1L<<OldPort->mp_SigBit);

      return(TRUE);
    }
  }
  return(FALSE);
}

void ReleaseSerial( void )
{
  if (xprseropen)
  {
    CloseDevice((struct IORequest*)xpr_serio);
  }

  if (xpr_serio) DeleteExtIO((struct IORequest*)xpr_serio);

  if (NewPort) DeletePort(NewPort);
}



// ************* XPR Functions ***************


LONG __saveds __asm xpr_finfo(register __a0 STRPTR FileName,register __d0 LONG InfoType)
{
  struct FileInfoBlock FB;
  BPTR FL;
  LONG result=0;

#ifdef debugmode
  printf("xpr_finfo, FileName = \"%s\" type = %ld\n",FileName,InfoType);
#endif

  switch (InfoType)
  {
    case 1:

      if (TransferType==T_RECEIVE && DL_PathOK)
      {
        strcpy(outstr,DL_Path);
        strcat(outstr,FileName);
      }
      else
      {
        strcpy(outstr,FileName);
      }

      if(FL=Lock(outstr,SHARED_LOCK))
      {
        if (Examine(FL,&FB))
        {
          result=FB.fib_Size;
        }
        UnLock(FL);
      }
      else
      {
        DOOR_SysopText("Lock Failed!\r\n");
      }
      break;

    case 2:
      result = 1; // always a binary transfer
      break;
  }
#ifdef debugmode
  printf("xpr_finfo, returning = %ld\n",result);
#endif
  return((LONG)result);
}

LONG __saveds __asm xpr_ffirst(register __a0 STRPTR Buffer,register __a1 STRPTR Pattern)
{

  #ifdef debugmode
  printf("xpr_ffirst, pattern = \"%s\"\n",Pattern);
  #endif

  if (UL_Files)
  {
    CurrentFile=(struct FileBuffer*)UL_FileList->lh_Head;
    CurrentFileNum=1;
    strcpy(Buffer,CurrentFile->node.ln_Name);
  }

  #ifdef debugmode
  printf("xpr_ffirst, buffer now = \"%s\"\n",Buffer);
  #endif
  return(1);
}

LONG __saveds __asm xpr_fnext(register __d0 LONG OldState,register __a0 STRPTR Buffer,register __a1 STRPTR Pattern)
{
  #ifdef debugmode
  printf("xpr_fnext, OldState = %ld, pattern = \"%s\"\n",OldState,Pattern);
  #endif

  if (CurrentFileNum<UL_Files)
  {
    CurrentFile=(struct FileBuffer*)CurrentFile->node.ln_Succ;
    CurrentFileNum++;
    strcpy(Buffer,CurrentFile->node.ln_Name);
    #ifdef debugmode
    printf("xpr_fnext, filename: %s, returning 1",Buffer);
    #endif
    return((LONG)1);
  }
  #ifdef debugmode
  printf("No more files for xpr_fnext\n");
  #endif
  return((LONG)0);
}

LONG __saveds __asm xpr_gets(register __a0 STRPTR Prompt,register __a1 STRPTR Buffer)
{
  #ifdef debugmode
  printf("xpr_gets, Prompt = \"%s\", Buffer = \"%s\"\n",Prompt,Buffer);
  #endif
  return((LONG)0);
}

LONG __saveds __asm xpr_fopen(register __a0 STRPTR FileName,register __a1 STRPTR AccessMode)
{
  BPTR FL;
  BOOL FileExists=FALSE;
  UBYTE tmpfilename[1024],newname[1024];
  struct ConfData *Conf=NULL;
  struct Node *node;
  struct NodeData *nd;

  #ifdef debugmode
  sprintf(outstr,"xpr_open, file = \"%s\", mode = \"%s\"\r\n",FileName,AccessMode);
  DOOR_SysopText(outstr);
  #endif

  if (stricmp(AccessMode,"r")==0)
  {
    if (TransferType==T_RECEIVE)
    {
      // *C* check here for existance of file in the PartUploads dir and move it to the
      // playpen.. Also check in the current conference's dl_paths (if in a conf..)

      if ((CheckConfPaths) && (Conf=FindConf()))
      {
        for (node=Conf->Download->lh_Head;!FileExists && node->ln_Succ;node=node->ln_Succ)
        {
          strcpy(tmpfilename,node->ln_Name);
          strcat(tmpfilename,FileName);
          if (PathOK(tmpfilename)) FileExists=TRUE;
        }

        if (!FileExists) // now check in the other nodes playpen dirs to see if
        {                // someone else is uploading the same file..
          for (nd=(struct NodeData *)BBSGlobal->NodeList->lh_Head;!FileExists && nd->node.ln_Succ;nd=(struct NodeData*)nd->node.ln_Succ)
          {
            strcpy(tmpfilename,nd->NodeSettings.NodePlayPen);
            AddPart(tmpfilename,FileName,1024);
            if (PathOK(tmpfilename)) FileExists=TRUE;
          }
        }

        if (!FileExists)
        {
          // check in partupload directory and if present copy to playpen so user can
          // resume the u/l..

          for (node=Conf->PartUpload->lh_Head;!FileExists && node->ln_Succ;node=node->ln_Succ)
          {
            sprintf(tmpfilename,"%s%s@%ld",node->ln_Name,FileName,N_ND->User.CallData.UserID);
            if (PathOK(tmpfilename))
            {
              strcpy(newname,DL_Path);
              AddPart(newname,FileName,1024);
              Rename(tmpfilename,newname);    // *C* change and add a copy here if rename fails!!
              FileExists=TRUE;
            }
          }
          FileExists=FALSE; // as we don't want to skip anymore..
        }

      }

      if ((FileExists) || (!DL_PathOK))
      {
        // file exists, no path specified
        #ifdef debugmode
        puts("file exists or no dlpath");
        #endif
        return(0); // this will cause the file to be SKIPPED
      }

      CurrentFile=NULL;

      strcpy(tmpfilename,DL_Path);
      AddPart(tmpfilename,FileName,1024);

      if (CurrentFile=(struct FileBuffer*)HBBS_CreateNode(tmpfilename,sizeof(struct FileBuffer)))
      {
        CurrentFile->Testing=TRUE;
      }
    }

    if (TransferType==T_SEND)
    {
      if (stricmp(FileName,CurrentFile->node.ln_Name)!=0)
      {
        printf("Where the fuck did this filename come from ??\n: %s\n",FileName);
        return(0);
      }
    }
  }
  else // transfer is a download (i.e. user sending the BBS a file.
  {
    // transfer is a download, so add the path of the download directory
    // to the FileName

    strcpy(tmpfilename,DL_Path);
    strcat(tmpfilename,FileName);

    if (CurrentFile=(struct FileBuffer*)HBBS_CreateNode(tmpfilename,sizeof(struct FileBuffer)))
    {
      AddTail(DL_FileList,(struct Node*)CurrentFile);
      DL_Files++;
    }
  }

  if (!CurrentFile) // *R* needed ?
  {
    return(0);
  }

  switch(AccessMode[0])
  {
    case 'r':
      // open the file, if it fails and we're sending a file then add the u/l path to the filename
      CurrentFile->FH=Open(CurrentFile->node.ln_Name,AccessMode[1]=='+' ? MODE_READWRITE : MODE_OLDFILE);

/* not used here... see at param checking part of program!
      if (!(CurrentFile->FH=Open(CurrentFile->node.ln_Name,AccessMode[1]=='+' ? MODE_READWRITE : MODE_OLDFILE)))
      {
        if (UL_PathOK && TransferType==T_SEND)
        {
          FreeStr(CurrentFile->node.ln_Name);
          strcpy(tmpfilename,UL_Path);
          AddPart(tmpfilename,FileName,1023);
          if (CurrentFile->node.ln_Name=DupStr(tmpfilename))
          {
            CurrentFile->FH=Open(CurrentFile->node.ln_Name,AccessMode[1]=='+' ? MODE_READWRITE : MODE_OLDFILE);
          }
        }
      }
*/
      break;
    case 'w':
      // open file for writing, truncate old file if it exists
      if (AccessMode[1]=='+')  // truncate file (well, delete it anyway)
      {
        if (FL = Lock(CurrentFile->node.ln_Name,ACCESS_WRITE))
        {
          UnLock(FL);
          DeleteFile(CurrentFile->node.ln_Name);
        }
        CurrentFile->FH=Open(CurrentFile->node.ln_Name,MODE_READWRITE);
      }
      else
      {
        CurrentFile->FH=Open(CurrentFile->node.ln_Name,MODE_NEWFILE);
      }
      break;
    case 'a':
      // open file, seek to end, create new file if none exists.

      if (FL=Lock(CurrentFile->node.ln_Name,ACCESS_WRITE))
      {
        UnLock(FL);
        if(CurrentFile->FH=Open(CurrentFile->node.ln_Name,MODE_READWRITE))
        {
          DOOR_SysopText("seeking..");
          if (Seek(CurrentFile->FH,0,OFFSET_END) == -1) // error seeking ?
          {
            Close(CurrentFile->FH);
            CurrentFile->FH = NULL;
          } else DOOR_SysopText("ok!\r\n");
        }
      }
      else
      {
        CurrentFile->FH=Open(CurrentFile->node.ln_Name,MODE_NEWFILE);
      }
      break;
  }

  if (CurrentFile->FH==NULL) // open failed!
  {
    if (CurrentFile->Testing)
    {
      HBBS_FreeNode((struct Node*)CurrentFile,FALSE);
    }
    return(NULL);
  }

  #ifdef debugmode
  printf("xpr_fopen, returning %x\r\n",(LONG)CurrentFile);
  #endif


  return((LONG)CurrentFile);
}

LONG __saveds __asm xpr_fclose(register __a0 struct FileBuffer *FileBuf)
{
#ifdef debugmode
  printf("xpr_fclose, FileBuf->Filename = \"%s\" FileBuf->FH = %x\n",FileBuf->node.ln_Name,FileBuf->FH);
#endif
  if ((FileBuf) && (FileBuf->FH))
  {
    Close(FileBuf->FH);
    if (FileBuf->Testing)
    {
      HBBS_FreeNode((struct Node*)FileBuf,FALSE);
    }
  }
  return((LONG)0);
}

LONG __saveds __asm xpr_fread(register __a0 APTR Buffer,register __d0 LONG Size,register __d1 long Count,register __a1 struct FileBuffer *FileBuf)
{
  LONG retval;
#ifdef debugmode
  printf("xpr_fread, Size = %ld, Count = %ld\n",Size,Count);
#endif
  // check params are ok..
  if (!Size)
  {
#ifdef debugmode
    puts("xpr_fread size = 0!");
#endif
    return(0);
  }
//  if (Buffer == NULL || FileBuf==NULL || FileBuf->FH==NULL || Size==0 || Count==0) return((LONG)0);
  retval=Read(FileBuf->FH,Buffer,Size*Count);
#ifdef debugmode
  printf("xpr_fread returning %ld\n",retval);
#endif

  if (retval) FileBuf->ReadFile=TRUE; // so we can determine if a file was skipped if it was
                                      // already present on the user's machine (not the sysop's)

  return(retval);
}

LONG __saveds __asm xpr_fwrite(register __a0 APTR Buffer,register __d0 LONG Size,register __d1 LONG Count,register __a1 struct FileBuffer *FileBuf)
{
  LONG retval;
#ifdef debugmode
  printf("xpr_write, Size = %ld, Count = %ld\n",Size,Count);
#endif

//  return(Size * Count);

  // check params are ok..
//  if (Buffer == NULL || FileBuf==NULL || FileBuf->FH==NULL || Size==0 || Count==0) return((LONG)0);
  if (!Size)
  {
#ifdef debugmode
    puts("xpr_fwrite size = 0!");
#endif
    return(0);
  }
  retval=Write(FileBuf->FH,Buffer,Size*Count);
#ifdef debugmode
  printf("xpr_write returning %ld\n",retval);
#endif
  return(retval);
}

LONG __saveds __asm xpr_fseek(register __a0 struct FileBuffer *FileBuf,register __d0 LONG Offset,register __d1 LONG Origin)
{
  LONG Mode=-1;
  LONG tmpval;

#ifdef debugmode
  printf("xpr_seek, Offset = %ld, Origin = %ld\n",Offset,Origin);
#endif

  // check params are ok..
  if (FileBuf==NULL || FileBuf->FH==NULL) return((LONG)-1);

  switch(Origin)
  {
    case 0: Mode=OFFSET_BEGINNING; break;
    case 1: Mode=OFFSET_CURRENT; break;
    case 2: Mode=OFFSET_END; break;
    default: return((LONG)-1);
  }
  tmpval=Seek(FileBuf->FH,Offset,Mode);
#ifdef debugmode
  printf("xpr_seek, seek() result = %ld\r\n",tmpval);
#endif
  return((tmpval==-1) ? (LONG)-1 : (LONG)0);

}

LONG __saveds __asm xpr_unlink(register __a0 STRPTR FileName)
{
#ifdef debugmode
  printf("xpr_unlick, FileName = \"%s\"\n",FileName);
#endif
  return(DeleteFile(FileName));
}

void xpr_closedisplay(void)
{
#ifdef debugmode
  printf("xpr_closedisplay\n");
#endif
  return;
}

LONG __saveds __asm xpr_displayupdate(register __a0 struct XPR_UPDATE *xu)
{
  long ud=xu->xpru_updatemask;
  LONG tempnum;

  if(ud&XPRU_BYTES)
  {
    if (CurrentFile)
    {
      CurrentFile->BytesTransferred=xu->xpru_bytes;

      if (TWindowOpen)
      {
        GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Transferred],XPRWin,NULL,GTNM_Number,(LONG)xu->xpru_bytes,TAG_DONE);

        if (CurrentFile->ActualSize) tempnum=(LONG)((CurrentFile->BytesTransferred * 100) / CurrentFile->ActualSize); else tempnum=0;
        GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Percent],XPRWin,NULL,GTNM_Number,(LONG)tempnum,TAG_DONE);

        tempnum=CurrentFile->ActualSize - CurrentFile->BytesTransferred;
        GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Remaining],XPRWin,NULL,GTNM_Number,(LONG)tempnum,TAG_DONE);
      }
    }

  }

  if(ud&XPRU_PROTOCOL)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Library],XPRWin,NULL,GTTX_Text,xu->xpru_protocol,TAG_DONE);
    }
  }
  if(ud&XPRU_FILENAME)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_File],XPRWin,NULL,GTTX_Text,xu->xpru_filename,TAG_DONE);
    }
  }
  if(ud&XPRU_FILESIZE)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Size],XPRWin,NULL,GTNM_Number,(LONG)xu->xpru_filesize,TAG_DONE);
    }

    if (CurrentFile)
    {
      CurrentFile->ActualSize=xu->xpru_filesize;
    }
  }
  if(ud&XPRU_MSG)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Message],XPRWin,NULL,GTTX_Text,xu->xpru_msg,TAG_DONE);
    }

  }
  if(ud&XPRU_BLOCKS)
  {
    if (CurrentFile)
    {
      CurrentFile->BlocksTransferred=xu->xpru_blocks;
    }
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Blocks],XPRWin,NULL,GTNM_Number,(LONG)xu->xpru_blocks,TAG_DONE);
    }
  }
  if(ud&XPRU_ERRORMSG)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Message],XPRWin,NULL,GTTX_Text,xu->xpru_errormsg,TAG_DONE);
    }
  }

  if(ud&XPRU_DATARATE)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_CPS],XPRWin,NULL,GTNM_Number,(LONG)xu->xpru_datarate,TAG_DONE);
    }
  }
  if(ud&XPRU_BLOCKSIZE)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_BlockSize],XPRWin,NULL,GTNM_Number,(LONG)xu->xpru_blocksize,TAG_DONE);
    }
  }
  if(ud&XPRU_ERRORS)
  {
    if (TWindowOpen)
    {
      GT_SetGadgetAttrs(XPRWinGadgets[XPRWin_Errors],XPRWin,NULL,GTNM_Number,(LONG)xu->xpru_errors,TAG_DONE);
    }
  }

  /*
  if(ud&XPRU_ELAPSEDTIME)printf("%d Elapsed Time\n",xu->xpru_elapsedtime);
  if(ud&XPRU_EXPECTTIME) printf("%d ExpectTime\n",xu->xpru_expecttime);
  if(ud&XPRU_BLOCKCHECK) printf("%d Block Check\n",xu->xpru_blockcheck);
  */

  return(0);
}

LONG __saveds __asm xpr_swrite(register __a0 APTR Buffer,register __d0 LONG Size)
{
#ifdef debugmode
  printf("xpr_swrite, Size = %ld\n",Size);
#endif
  if (Size==0)
  {
#ifdef debugmode
    puts("xpr_swrite invalid size!");
#endif
    return((LONG)0);
  }

  xpr_serio->IOSer.io_Length=Size;
  xpr_serio->IOSer.io_Data=Buffer;
  xpr_serio->IOSer.io_Command=CMD_WRITE;
  SetSignal(0,1L<<NewPort->mp_SigBit);
  DoIO((struct IORequest *)xpr_serio);
#ifdef debugmode
  printf("xpr_swrite returning %ld\n",xpr_serio->IOSer.io_Error);
#endif
  return((LONG)xpr_serio->IOSer.io_Error);
}


LONG __saveds __asm xpr_chk4abort(void)
{
  struct IntuiMessage *im=0;
  LONG retval=0;

  if(TWindowOpen)
  {
    if (im=(struct IntuiMessage *)GetMsg(XPRWin->UserPort))
    {
      // We've only got one type of message, so it must be the close gadget
      // being pressed!

      ReplyMsg((struct Message *)im);
      retval=-1;

    }
  }

  if (CarrierLost()) retval=-1;

#ifdef debugmode
  printf("xpr_chkabort returning %ld\n",retval);
#endif
  return(retval);
}


LONG __saveds __asm xpr_sread(register __a0 APTR Buffer,register __d0 LONG Size,register __d1 ULONG Timeout)
{
  ULONG WaitSigs,ReturnedSigs;

  LONG BytesWaiting,AmountToRead;


#ifdef debugmode
  printf("xpr_sread, Size = %ld, Timeout = %ld\n",Size,Timeout);
#endif

  if (Size==0)
  {
#ifdef debugmode
    puts("xpr_sread invalid size");
#endif
    return((LONG)0);
  }

  if (CarrierLost()) return((LONG)-1);

  /* See how many bytes there are */

  xpr_serio->IOSer.io_Command=SDCMD_QUERY;
  DoIO((struct IORequest *)xpr_serio);
  BytesWaiting=xpr_serio->IOSer.io_Actual;

#ifdef debugmode
  printf("%d Bytes Waiting\n",BytesWaiting);
#endif

  if(!Timeout || BytesWaiting >= Size)
  {
    if(!BytesWaiting)
    {
      // no data to be read..
      return(0);
    }
    else
    {
      // some data is waiting
      if(BytesWaiting>Size) AmountToRead=Size;
      xpr_serio->IOSer.io_Command=CMD_READ;
      xpr_serio->IOSer.io_Data=Buffer;
      xpr_serio->IOSer.io_Length=AmountToRead;
      DoIO((struct IORequest *)xpr_serio);

      // return amount of bytes read
#ifdef debugmode
      printf("xpr_sread, returning %ld\n",AmountToRead);
#endif
      return((LONG)AmountToRead);
    }
  }

  xpr_serio->IOSer.io_Command=CMD_READ;
  xpr_serio->IOSer.io_Data=Buffer;
  xpr_serio->IOSer.io_Length=Size;

  SetSignal(0,1L<<NewPort->mp_SigBit);
  SendIO((struct IORequest *)xpr_serio);

  qtimer(Timeout);

  WaitSigs=(1L<<tport->mp_SigBit) | (1L<<NewPort->mp_SigBit);
  if (TWindowOpen) WaitSigs|=(1L << XPRWin->UserPort->mp_SigBit);

  ReturnedSigs=Wait(WaitSigs);

  if (ReturnedSigs & (1L << XPRWin->UserPort->mp_SigBit))
  {
#ifdef debugmode
    puts("window flag");
#endif
    if (xpr_chk4abort()==-1)
    {
      // abort everything, tidy up and return -1

      if (!CheckIO((struct IORequest *)xpr_serio))
      {
        AbortIO((struct IORequest *)xpr_serio);
      }
      WaitIO((struct IORequest *)xpr_serio);

      AbortIO((struct IORequest *)treq);
      WaitIO((struct IORequest *)treq);

      // cancel the transfer!
      xpr_swrite(ZModemCancel,20);

      #ifdef debugmode
      puts("xpr_sread, returning -1, aborted!");
      #endif
      return((LONG)-1);
    }
    // if we get here then it was not a cancel message that we received from
    // the window, so we can sit in the main loop abit more and wait for
    // another signal..
  }

  if (ReturnedSigs&(1L<<NewPort->mp_SigBit))
  {
    #ifdef debugmode
    puts("Serial Flag");
    #endif
    if (!CheckIO((struct IORequest *)xpr_serio))
    {
      AbortIO((struct IORequest *)xpr_serio);
    }
    WaitIO((struct IORequest *)xpr_serio);

    // and cleanup the timer and serial requests
    AbortIO((struct IORequest *)treq);
    WaitIO((struct IORequest *)treq);

    // and just in case any bytes were read by the serial port, return the amount
    // would be 0 if a timeout occured and no data was read

    #ifdef debugmode
    printf("xpr_sread, returning %ld\n",xpr_serio->IOSer.io_Actual);
    #endif
    return((LONG)xpr_serio->IOSer.io_Actual);
  }

  if (ReturnedSigs&(1L<<tport->mp_SigBit))
  {
    #ifdef debugmode
    puts("Timer Flag");
    #endif
    if (!CheckIO((struct IORequest *)xpr_serio))
    {
      AbortIO((struct IORequest *)xpr_serio);
    }
    WaitIO((struct IORequest *)xpr_serio);

    AbortIO((struct IORequest *)treq);
    WaitIO((struct IORequest *)treq);

    #ifdef debugmode
    printf("xpr_sread, returning %ld\n",xpr_serio->IOSer.io_Actual);
    #endif
    return((LONG)xpr_serio->IOSer.io_Actual);
  }

  // Should Never Get Here, if it does a false signal arrived!
  DOOR_SysopText("XPR Error - SR1\r\n");
  return(0);
}

LONG __saveds __asm xpr_sflush(void)
{
#ifdef debugmode
  printf("xpr_sflush\n");
#endif

  xpr_serio->IOSer.io_Command=CMD_FLUSH;
  DoIO((struct IORequest *)xpr_serio);
  return((LONG)xpr_serio->IOSer.io_Error);
}

#define ST_PARTYON  (1 << 0)
#define ST_PARTYODD (1 << 1)
#define ST_7WIRE  (1 << 2)
#define ST_QBREAK (1 << 3)
#define ST_RADBOOGIE  (1 << 4)
#define ST_SHARED (1 << 5)
#define ST_EOFMODE  (1 << 6)
#define ST_XDISABLED  (1 << 7)
#define ST_PARTYMARKON  (1 << 8)
#define ST_PARTYMARK  (1 << 9)
#define ST_2BITS  (1 << 10)
#define ST_READ7  (1 << 11)
#define ST_WRITE7 (1 << 12)

LONG __saveds __asm xpr_setserial(register __d0 LONG Status)
{
  STATIC LONG XprBauds[12] =
  {
    110,
    300,
    1200,
    2400,
    4800,
    9600,
    19200,
    31250,
    38400,
    57600,
    76800,
    115200
  };

  LONG Return,i;

#ifdef debugmode
  printf("xpr_setserial, status = %ld\n",Status);
#endif

  xpr_serio -> IOSer . io_Command = SDCMD_QUERY;
  DoIO((struct IORequest *)xpr_serio);

  Return = xpr_serio -> io_SerFlags & 0xFF;

  if(xpr_serio -> io_ExtFlags & SEXTF_MSPON)
    Return |= ST_PARTYMARKON;

  if(xpr_serio -> io_ExtFlags & SEXTF_MARK)
    Return |= ST_PARTYMARK;

  if(xpr_serio -> io_StopBits == 2)
    Return |= ST_2BITS;

  if(xpr_serio -> io_ReadLen == 7)
    Return |= ST_READ7;

  if(xpr_serio -> io_WriteLen == 7)
    Return |= ST_WRITE7;

  for(i = 0 ; i < 12 ; i++)
  {
    if(xpr_serio -> io_Baud == XprBauds[i])
    {
      Return |= (i << 16);   // uses 16MSB's of the LONGWORD for the speed ?

      break;
    }
  }

  if(Status != -1)
  {
    xpr_serio -> IOSer . io_Command = SDCMD_SETPARAMS;

    xpr_serio -> io_SerFlags    = Status & 0xFF;
    xpr_serio -> io_ExtFlags    = 0;

    if(Status & ST_PARTYMARKON)
      xpr_serio -> io_ExtFlags |= SEXTF_MSPON;

    if(Status & ST_PARTYMARK)
      xpr_serio -> io_ExtFlags |= SEXTF_MARK;

    if(Status & ST_2BITS)
      xpr_serio -> io_StopBits = 2;
    else
      xpr_serio -> io_StopBits = 1;

    if(Status & ST_READ7)
      xpr_serio -> io_ReadLen = 7;
    else
      xpr_serio -> io_ReadLen = 8;

    if(Status & ST_WRITE7)
      xpr_serio -> io_WriteLen = 7;
    else
      xpr_serio -> io_WriteLen = 8;

    DoIO((struct IORequest *)xpr_serio);

  }

  return(Return);

}
/* EOT [end of theft] */

void OpenTransferWindow( void )
{
  struct Screen *Scr=NULL;

  if (!TWindowOpen)
  {
    if (HBBSFont=OpenDiskFont( &HBBS8066 ) )
    {
      if (N_ND->ConOK && N_ND->NodeSettings.UseOwnScreen)
      {
        sprintf(outstr,"NodeWatch_%d",N_ND->NodeNum);
        Scr = LockPubScreen(outstr);
      }
      if (!Scr)
      {
        Scr = LockPubScreen( "CtrlScrn" );
      }
      if (Scr)
      {
        if (OpenWindowXPRWin(Scr)==0)
        {
          // Opened OK
          TWindowOpen=TRUE;
        }
        UnlockPubScreen( NULL, Scr);
      }
    }
  }
}

void CloseTransferWindow( void )
{
  if (HBBSFont) CloseFont(HBBSFont);
  if (TWindowOpen)
  {
    CloseWindowXPRWin();
    TWindowOpen=FALSE;
  }
}

void KeepFlushing( void )
{
  BOOL Done=FALSE;

  do
  {
    switch(DOOR_GetLine(GL_IMMEDIATE,'\0',1,2,NULL))
    {
      case IN_LOSSCARRIER:
      case IN_TIMEOUT:
        Done=TRUE;
        break;
    }
  } while (!Done);
}

void Xfer( void )
{
  if (XProtocolBase=OpenLibrary(xprlibname,0))
  {
    if (xio=(struct XPR_IO*)AllocVec(sizeof (struct XPR_IO),MEMF_CLEAR))
    {
      xio->xpr_fopen     = xpr_fopen;
      xio->xpr_fclose    = xpr_fclose;
      xio->xpr_fread     = xpr_fread;
      xio->xpr_fwrite    = xpr_fwrite;

      xio->xpr_swrite    = xpr_swrite;
      xio->xpr_sread     = xpr_sread;
      xio->xpr_sflush    = xpr_sflush;
      xio->xpr_setserial = xpr_setserial;

      xio->xpr_update    = xpr_displayupdate;
      xio->xpr_chkabort  = xpr_chk4abort;
      xio->xpr_ffirst    = xpr_ffirst;
      xio->xpr_fnext     = xpr_fnext;
      xio->xpr_finfo     = xpr_finfo;
      xio->xpr_fseek     = xpr_fseek;
      xio->xpr_gets      = xpr_gets;
      xio->xpr_unlink    = xpr_unlink;

      AbortSerRead();

      if (GrabSerial())
      {
        // from this point on DON'T USE DOOR_WriteText(), use DOOR_SysopText() instead!
        // or you will corrupt the transfer!

        if (opentimer()==0)
        {

          xio->xpr_filename=xprlibopts;


//          DOOR_SysopText("protocol options= \"");
//          if (xprlibopts) DOOR_SysopText(xprlibopts);
//          DOOR_SysopText("\"\r\n");

          OpenTransferWindow();

          if(XProtocolSetup(xio))
          {

            if (UL_Files) // Uploading ??
            {
              // init filename with finename of first the first..

              xio->xpr_filename=HBBS_ListName(UL_FileList,0);
              TransferType=T_SEND;
              XProtocolSend(xio);
            }
            else // nope, Downloading ?
            {
              if (DL_PathOK)
              {
                // Yup...

                // init filename with path to download files..

                xio->xpr_filename=DL_Path;

                TransferType=T_RECEIVE;
                XProtocolReceive(xio);
              }
            }
            XProtocolCleanup(xio);
          }

          CloseTransferWindow();

          closetimer();
        }
        else
        {
          DOOR_SysopText("Failed To Open Timer!\r\n");
        }
        ReleaseSerial();

        KeepFlushing();

      }
      else
      {
        DOOR_WriteText("Failed To Open Serial!\r\n");
      }
      FreeVec(xio);
    }
    CloseLibrary(XProtocolBase);
  }
  else
  {
    DOOR_WriteText("Failed to open \"");
    DOOR_WriteText(xprlibname);
    DOOR_WriteText("\" Exiting!\r\n");
  }

}

void CheckULList(void)
{
  struct FileBuffer *node;
  struct TaggedFile *Tag;

  for (node = (struct FileBuffer *)UL_FileList->lh_Head ; node->node.ln_Succ ; node =(struct FileBuffer *)node->node.ln_Succ)
  {
    if (node->ActualSize==node->BytesTransferred)
    {
      N_ND->Actions[ACTN_DOWNLOAD]=ACTC_DOWNLOAD;

      // transferred the file ok, remove creds (if applicable)
      // and write to callers log and ul/dl log..

      sprintf(outstr,"DOWNLOADED File:\"%s\" Size:%ld",node->node.ln_Name,node->ActualSize);
      HBBS_AddToCallersLog(outstr);

      N_ND->User.CallData.ActualDownloadFiles++;
      N_ND->User.NormalData.ActualDownloadFiles++;
      N_ND->User.CallData.ActualDownloadBytes+=node->ActualSize;
      N_ND->User.NormalData.ActualDownloadBytes+=node->ActualSize;

      N_ND->User.FilesDownloaded++;
      N_ND->User.BytesDownloaded+=node->ActualSize;

      if (Tag=HBBS_FindTag(node->node.ln_Name,TRUE))
      {
        if (TakeCreds && Tag->WarezFile && node->BlocksTransferred && N_ND->User.Valid && node->ReadFile)
        {
          sprintf(outstr,ANSI_RESET ANSI_FG_CYAN "Removing "ANSI_FG_WHITE"%6ld"ANSI_FG_CYAN" credits for file: "ANSI_FG_WHITE"%s\r\n",node->ActualSize,FilePart(node->node.ln_Name));
          DOOR_WriteText(outstr);

          N_ND->User.CallData.DownloadFiles++;
          N_ND->User.NormalData.DownloadFiles++;

          N_ND->User.CallData.DownloadBytes+=Tag->FileSize;
          N_ND->User.NormalData.DownloadBytes+=Tag->FileSize;
        }

        // and remove the tagged file

        N_ND->TaggedFiles--; // first! :-)
        Remove((struct Node*)Tag);

        FreeStr(Tag->node.ln_Name);
        FreeVec(Tag);
      }


    }
    else
    {
      // *C* add U/D log too..
      // failed transferring that file, leave it tagged and write to the log..
      sprintf(outstr,"FAILED DOWNLOAD File:\"%s\" Size:%ld Transferred:%ld",node->node.ln_Name,node->ActualSize,node->BytesTransferred);
      HBBS_AddToCallersLog(outstr);
      N_ND->Actions[ACTN_FAILEDDOWNLOAD]=ACTC_FAILEDDOWNLOAD;

    }
  }
}

void CheckDLList(void)
{
  struct FileBuffer *node;

  for (node = (struct FileBuffer *)DL_FileList->lh_Head ; node->node.ln_Succ ; node =(struct FileBuffer *)node->node.ln_Succ)
  {
    if (node->ActualSize==node->BytesTransferred)
    {
      // transferred the file ok, add creds (if applicable)
      // and write to callers log and ul/dl log..

      N_ND->User.CallData.ActualUploadFiles++;
      N_ND->User.NormalData.ActualUploadFiles++;
      N_ND->User.CallData.ActualUploadBytes+=node->ActualSize;
      N_ND->User.NormalData.ActualUploadBytes+=node->ActualSize;

      N_ND->User.FilesUploaded++;
      N_ND->User.BytesUploaded+=node->ActualSize;

      sprintf(outstr,"UPLOADED File:\"%s\" Size:%ld",node->node.ln_Name,node->ActualSize);
      HBBS_AddToCallersLog(outstr);
      N_ND->Actions[ACTN_UPLOAD]=ACTC_UPLOAD;


    }
    else
    {
      // *C* add U/D log too..
      // failed transferring that file, leave it tagged and write to the log..

      N_ND->Actions[ACTN_FAILEDUPLOAD]=ACTC_FAILEDUPLOAD;

      sprintf(outstr,"FAILED UPLOAD File:\"%s\" Size:%ld Transferred:%ld",node->node.ln_Name,node->ActualSize,node->BytesTransferred);
      HBBS_AddToCallersLog(outstr);


      sprintf(outstr,ANSI_RESET ANSI_FG_CYAN "Moving failed file"ANSI_FG_BLUE": "ANSI_FG_WHITE"%s"ANSI_FG_CYAN" Size"ANSI_FG_BLUE": "ANSI_FG_WHITE"%ld\r\n",node->node.ln_Name,node->BytesTransferred);
      DOOR_WriteText(outstr);

      sprintf(outstr,"%s@%ld",node->node.ln_Name,N_ND->User.CallData.UserID);

      if (Rename(node->node.ln_Name,outstr))
      {
        sprintf(outstr,"%sPARTUPLOAD %s@%ld",N_ND->OnlineStatus==OS_ONLINE ? "" : "NOUSER ",FilePart(node->node.ln_Name),N_ND->User.CallData.UserID); // move NOUSER to the door's system options!!!
        DOOR_SystemDoor("MoveFile",outstr);
      }
      else
      {
        DeleteFile(node->node.ln_Name);
      }

    }
  }
}

void DoorMain(int argc,char *argv[])
{
  long loop;

  BOOL AddTags=0;
  BOOL SystemFiles=TRUE;
  BOOL WarezFiles=TRUE;

  struct TaggedFile *Tag;
  struct FileBuffer *NewFileNode;
  char tmpname[1024];

  BPTR FL;
  struct FileInfoBlock FB;


  if (UL_FileList=HBBS_CreateList())
  {
    if (DL_FileList=HBBS_CreateList())
    {
      xprlibname=argv[2];

      // add list of tagged files to our list of files to transfer..


      // then check the parameters to see if we have any other options..
      // remembering to miss out the arguments that we've already checked
      // (hence starting the loop from startparam)

      for(loop=3;loop<argc;loop++) // if there are any parameters then display them
      {
        switch(toupper(argv[loop][0]))
        {
          case 'S' :
            CheckConfPaths=TRUE;
            break;

          case 'C' :
            TakeCreds=TRUE;
            break;

          case 'U' :
            strcpy(tmpname,&argv[loop][2]);
            if (!(FL=Lock(tmpname,SHARED_LOCK))) // does the file exist ?
            {
              if (UL_PathOK)
              {
                strcpy(tmpname,UL_Path);
                strcat(tmpname,&argv[loop][2]); // same as argv[loop]+2, start at 3rd char..
                FL=Lock(tmpname,SHARED_LOCK);
              }
            }
            if (FL)
            {
              if (Examine(FL,&FB))
              {
                if (NewFileNode=(struct FileBuffer*)HBBS_CreateNode(tmpname,sizeof(struct FileBuffer)))
                {
                   // all othe rparams are set to null by HBBS_CreateNode()
                  NewFileNode->ActualSize=FB.fib_Size;
                  AddTail(UL_FileList,(struct Node *)NewFileNode);
                  UL_Files++;
                }

              }
              UnLock(FL);
            }

            break;

          case 'O' :
            xprlibopts=&argv[loop][2];
            break;

          case 'D' :
            if (!DL_PathOK) // only allowed ONE download path!
            {
              DL_Path=&argv[loop][2];
              if (PathOK(DL_Path)) DL_PathOK=TRUE;
            }
            break;

          case 'W' :
            if (!UL_PathOK) // only allowed ONE download path!
            {
              UL_Path=&argv[loop][2];
              if (PathOK(UL_Path)) UL_PathOK=TRUE;
            }
            break;

          default:
            if (stricmp(argv[loop],"TAGS")==0)
            {
              AddTags=TRUE;
            }

            if (stricmp(argv[loop],"NOSYSTEM")==0)
            {
              SystemFiles=FALSE;
            }

            if (stricmp(argv[loop],"NOWAREZ")==0)
            {
              WarezFiles=FALSE;
            }

            break;

        }
      }

      if (AddTags)
      {
        if (N_ND->TaggedFiles)
        {
          for (Tag=(struct TaggedFile *)N_ND->TaggedFileList->lh_Head;Tag->node.ln_Succ;Tag=(struct TaggedFile *)Tag->node.ln_Succ)
          {
            if (((Tag->WarezFile==TRUE) && (WarezFiles)) || ((Tag->WarezFile==FALSE) && (SystemFiles)))
            {
              if (NewFileNode=(struct FileBuffer*)HBBS_CreateNode(Tag->node.ln_Name,sizeof(struct FileBuffer)))
              {
                NewFileNode->ActualSize=Tag->FileSize;
                AddTail(UL_FileList,(struct Node*)NewFileNode);
                UL_Files++;
              }
            }
          }
        }
      }

      if ((xprlibname) && ((UL_Files || DL_PathOK)) )
      {
        Xfer();
      }
      DOOR_WriteText("\r\n");

      CheckDLList();
      FreeStrList(DL_FileList); // then free it!
    }
    CheckULList();
    FreeStrList(UL_FileList);


    HBBS_SaveUserData(&N_ND->User.NormalData);
    // just in case the user decided to loose carrier! :-)
    // or if the bbs crashed (heaven forbid..) before the data was saved normally.
  }
}

int main(int argc,char *argv[])
{
  if (sscanf(argv[1],"%d",&N_NodeNum)==0)
  {
    printf("Invalid/No Paramaters for door!\n");
    exit (20);
  }
  init("XPR");

  SetTaskPri(FindTask(0),2); // *C* make configurable!!!

  if (BBSGlobal=HBBS_GimmeBBS())
  {
    if (N_ND=HBBS_NodeDataPtr(N_NodeNum)) // this should not fail in normal circumstances..
    {
      DoorMain(argc,argv);
    }
  }
  cleanup(0);
}
